︠5bea9b44-9d1f-48b5-ae9d-6ad5ec48aa02i︠
%md
# Absolute versus Relative Number Fields
## (and source code -- how it works right now)
## William Stein
## Jan 15, 2016 (part 1)
︡822b4e67-f6f2-44b2-a5bc-a415c7277a11︡︡{"done":true,"md":"# Absolute versus Relative Number Fields\n## (and source code -- how it works right now)\n## William Stein\n## Jan 15, 2016 (part 1)"}
︠17819384-b1ff-4436-9c3d-e18472fbd592i︠
%md
Let's build a tower of number fields
︡f99c8ab6-c3a3-4e51-bac9-ad3a56ddacf3︡︡{"done":true,"md":"Let's build a tower of number fields"}
︠43e1ca3b-ca53-47a5-8933-bd7308a6e82a︠
R1.<x> = QQ[]
F1.<a> = NumberField(x^3 + 2*x + 1)
R2.<y> = F1[]
F2.<b> = NumberField(y^2 - a)
R3.<z> = F2[]
F3.<c> = NumberField(z^3 - b)
F3
︡40ba3050-252d-4ea7-bbd3-520c56df195f︡︡{"stdout":"Number Field in c with defining polynomial z^3 - b over its base field\n","done":false}︡{"done":true}
︠21bc4788-faf0-41ac-863f-773ae0f32630︠
c^3
︡f5ee835d-5bdc-49bc-aaf1-4bdb115c75b2︡︡{"stdout":"b\n","done":false}︡{"done":true}
︠8dcf95c1-80cb-465a-b766-eb4a8502dafb︠
F2
︡c96a93cd-368b-4ad2-8951-d4a83a1fe2aa︡︡{"stdout":"Number Field in b with defining polynomial y^2 - a over its base field\n","done":false}︡{"done":true}
︠cf553cc9-757c-4a7a-975f-f9035f51fdc5︠
b^2
︡e574049c-64e0-4e5d-8eb7-0b0571432cf1︡︡{"stdout":"a\n","done":false}︡{"done":true}
︠9471902e-048a-451d-8dfb-99b11203888f︠
F1
︡4a18eb4c-6498-4f57-a210-c8d82f105447︡︡{"stdout":"Number Field in a with defining polynomial x^3 + 2*x + 1\n","done":false}︡{"done":true}
︠583022f1-cade-4e8a-b79d-6ffd2e3e38e7︠
a^3
︡1c246795-711d-4769-846c-d53d504a595c︡︡{"stdout":"-2*a - 1\n","done":false}︡{"done":true}
︠5e45e1bd-0eb2-45f0-9191-8e2f7c79946b︠
(a+b+c)^3
︡50173d42-7324-4d6e-ad41-bd8e265c6055︡︡{"stdout":"(3*b + 3*a)*c^2 + (6*a*b + 3*a^2 + 3*a)*c + (3*a^2 + a + 1)*b + 3*a^2 - 2*a - 1\n","done":false}︡{"done":true}
︠307d602c-055a-4616-ab3b-eaf243e6bbc5︠
c._add_??
︡919def7e-c3aa-4214-ad9a-4ba3495d7dcc︡︡{"code":{"source":"   File: /projects/sage/sage-6.10/src/sage/rings/number_field/number_field_element.pyx\n   Source:\n       cpdef ModuleElement _add_(self, ModuleElement right):\n        r\"\"\"\n        EXAMPLE::\n\n            sage: K.<s> = QuadraticField(2)\n            sage: s + s # indirect doctest\n            2*s\n            sage: s + ZZ(3) # indirect doctest\n            s + 3\n        \"\"\"\n        cdef NumberFieldElement x\n        cdef NumberFieldElement _right = right\n        x = self._new()\n        ZZ_mul(x.__denominator, self.__denominator, _right.__denominator)\n        cdef ZZX_c t1, t2\n        ZZX_mul_ZZ(t1, self.__numerator, _right.__denominator)\n        ZZX_mul_ZZ(t2, _right.__numerator, self.__denominator)\n        ZZX_add(x.__numerator, t1, t2)\n        x._reduce_c_()\n        return x\n","mode":"python","lineno":-1,"filename":null},"done":false}︡{"done":true}
︠057a55fe-f825-427e-ad9a-536b5a3b2ed6i︠
%md
Type
<br />
<br />


    open /projects/sage/sage-6.10/src/sage/rings/number_field/number_field_element.pyx

<br />


in a file `term.term` or browse to that file on Github:

https://github.com/sagemath/sage/blob/master/src/sage/rings/number_field/number_field_element.pyx

<br/>
I also put a copy of number_field_element.pyx in our lecture notes directory here.  Also see the corresponding pxd file, which defines the *data* of a number field element.
︡5e27dfac-d304-4a92-98f5-ffdb948562ea︡︡{"done":true,"md":"Type\n<br />\n<br />\n\n\n    open /projects/sage/sage-6.10/src/sage/rings/number_field/number_field_element.pyx\n\n<br />\n\n\nin a file `term.term` or browse to that file on Github:\n\nhttps://github.com/sagemath/sage/blob/master/src/sage/rings/number_field/number_field_element.pyx\n\n<br/>\nI also put a copy of number_field_element.pyx in our lecture notes directory here.  Also see the corresponding pxd file, which defines the *data* of a number field element."}
︠6bcd4be9-582b-446b-ac5e-a94d6ac14ed5︠
smc.link("number_field_element.pyx")
print
smc.link("number_field_element.pxd")
︡0a38016d-6beb-45ae-b982-659a742defee︡︡{"html":"<a class='' style='cursor:pointer'; id='dd4da351-7366-44d7-b244-86559f87433c'></a>","done":false}︡{"obj":"{\"path\": \"lectures/2016-01-13/number_field_element.pyx\", \"foreground\": true, \"label\": \"number_field_element.pyx\"}","javascript":{"coffeescript":false,"code":"$('#dd4da351-7366-44d7-b244-86559f87433c').html(obj.label).click(function() {worksheet.project_page.open_file({'path':obj.path, 'foreground': obj.foreground});; return false;});"},"done":false,"once":false}︡{"stdout":"\n","done":false}︡{"html":"<a class='' style='cursor:pointer'; id='25112de7-6b8a-49bd-a745-42012b32b84e'></a>","done":false}︡{"obj":"{\"path\": \"lectures/2016-01-13/number_field_element.pxd\", \"foreground\": true, \"label\": \"number_field_element.pxd\"}","javascript":{"coffeescript":false,"code":"$('#25112de7-6b8a-49bd-a745-42012b32b84e').html(obj.label).click(function() {worksheet.project_page.open_file({'path':obj.path, 'foreground': obj.foreground});; return false;});"},"done":false,"once":false}︡{"done":true}
︠6fdbceb8-9222-481b-a58a-6d8f562fe1d0i︠
%md
In SMC you can select all text (in number_field_element.pyx), then type Control+Q to fold all code.  This gives you a nice top-down view of the file.

Look at the file.

All number field elements are represented in terms of a single absolute polynomial over $\ZZ$ and a denominator using [the NTL C++ number theory library](http://www.shoup.net/ntl/).

This is simple, but it means that in some cases arithmetic can be stupidly slow compared to Magma (and in others, very fast).
︡cf371603-3291-4f1e-8133-f8229054f66c︡︡{"done":true,"md":"In SMC you can select all text (in number_field_element.pyx), then type Control+Q to fold all code.  This gives you a nice top-down view of the file.\n\nLook at the file.\n\nAll number field elements are represented in terms of a single absolute polynomial over $\\ZZ$ and a denominator using [the NTL C++ number theory library](http://www.shoup.net/ntl/).\n\nThis is simple, but it means that in some cases arithmetic can be stupidly slow compared to Magma (and in others, very fast)."}
︠4c798cd5-d29d-4eac-830d-d39aa0155c9c︠
c.absolute_minpoly()
︡f699f254-ea2a-4817-8c01-fd3ab29082d2︡︡{"stdout":"x^18 + 2*x^6 + 1","done":false}︡{"stdout":"\n","done":false}︡{"done":true}
︠aab26c8d-5ae2-4be1-bf78-57cf9330a6eb︠
L.<alpha> = F3.absolute_field()
L
︡0da34d7c-501f-4272-89b1-532ebf519d28︡︡{"stdout":"Number Field in alpha with defining polynomial x^18 + 2*x^6 + 1\n","done":false}︡{"done":true}
︠20293f32-eec2-4a04-8e66-908d137444d8i︠
%md
The `structure` method allows you to recover an explicit isomorphisms between $L$ and $F_3$:
︡915b9827-d645-4e6d-8641-5cbfa3e89276︡︡{"done":true,"md":"The `structure` method allows you to recover an explicit isomorphisms between $L$ and $F_3$:"}
︠8c9bb4d6-c2b0-4976-ab41-ebd95f8ba777︠
L.structure?
︡e792a0dc-ead1-4b7c-b8ab-ff47179772f8︡︡{"code":{"source":"File: /projects/sage/sage-6.10/src/sage/rings/number_field/number_field.py\nSignature : L.structure()\nDocstring :\nReturn fixed isomorphism or embedding structure on self.\n\nThis is used to record various isomorphisms or embeddings that\narise naturally in other constructions.\n\nEXAMPLES:\n\n   sage: K.<z> = NumberField(x^2 + 3)\n   sage: L.<a> = K.absolute_field(); L\n   Number Field in a with defining polynomial x^2 + 3\n   sage: L.structure()\n   (Isomorphism given by variable name change map:\n     From: Number Field in a with defining polynomial x^2 + 3\n     To:   Number Field in z with defining polynomial x^2 + 3,\n    Isomorphism given by variable name change map:\n     From: Number Field in z with defining polynomial x^2 + 3\n     To:   Number Field in a with defining polynomial x^2 + 3)\n\n   sage: K.<a> = QuadraticField(-3)\n   sage: R.<y> = K[]\n   sage: D.<x0> = K.extension(y)\n   sage: D_abs.<y0> = D.absolute_field()\n   sage: D_abs.structure()[0](y0)\n   -a","mode":"text/x-rst","lineno":-1,"filename":null},"done":false}︡{"done":true}
︠30c54293-8eb2-456f-935d-880d70c26a13︠
from_L, to_L = L.structure()
︡16eff895-00b0-45d6-9020-59d3cb4224b8︡︡{"done":true}
︠4e25b204-9e74-4080-86b8-97781a602f83︠
from_L(alpha + 7)
︡d543db3d-f2d0-4162-a412-a5368700fd15︡︡{"stdout":"c + 7\n","done":false}︡{"done":true}
︠dfe98e99-a91b-4b09-ab71-9784e192e128︠
to_L(a + b + c)
︡a329573a-184a-4afc-b0d6-83e9c3de81f3︡︡{"stdout":"alpha^6 + alpha^3 + alpha\n","done":false}︡{"done":true}
︠b9909168-48c4-4805-bd99-df29eb887409i︠
%md
**WARNING:** use these morphisms!  Do not get lazy and just try turning things into lists and converting them (copying and pasting).  It'll lead to subtle bugs.
︡9bbbf9c9-eec3-4255-8a66-e0c6e2efed49︡︡{"done":true,"md":"**WARNING:** use these morphisms!  Do not get lazy and just try turning things into lists and converting them (copying and pasting).  It'll lead to subtle bugs."}
︠9f17a9fa-4394-43d7-b8de-1bca28848aa7︠
%time L.class_number(proof=False)
︡de34c340-3e97-4506-bde3-077618258ec5︡︡{"stdout":"1\n","done":false}︡{"stdout":"CPU time: 0.01 s, Wall time: 0.00 s\n","done":false}︡{"done":true}
︠b90987cd-f867-477e-a1c3-2fcf188535b9︠
%time F3.class_number(proof=False)
︡5dd81636-315d-4299-bdcc-4c64ef821fe6︡︡{"stdout":"1\n","done":false}︡{"stdout":"CPU time: 0.06 s, Wall time: 0.06 s\n","done":false}︡{"done":true}
︠c6caafff-0681-4191-8b5e-d2eb80c3bbc8︠









